uniform mat4 uMVPMatrix; 								//ܱ任
uniform mat4 uMMatrix; 									//任
uniform vec3 uLightLocation;								//Դλ
uniform vec3 uCamera;									//λ
attribute vec3 aPosition;  								//λ
attribute vec3 aNormal;    								//㷨
varying vec4 ambient;						//ڴݸƬԪɫĻǿ
varying vec4 diffuse;							//ڴݸƬԪɫɢǿ
varying vec4 specular; 						//ڴݸƬԪɫľǿ
varying float vFogFactor; 									//

//λռķ
void pointLight(					//λռķ
  in vec3 normal,				//
  inout vec4 ambient,			//ǿ
  inout vec4 diffuse,				//ɢǿ
  inout vec4 specular,			//ǿ
  in vec3 lightLocation,			//Դλ
  in vec4 lightAmbient,			//ǿ
  in vec4 lightDiffuse,			//ɢǿ
  in vec4 lightSpecular			//ǿ
){
  ambient=lightAmbient;			//ֱӵóǿ  
  vec3 normalTarget=aPosition+normal;	//任ķ
  vec3 newNormal=(uMMatrix*vec4(normalTarget,1)).xyz-(uMMatrix*vec4(aPosition,1)).xyz;
  newNormal=normalize(newNormal); 	//Է
  //ӱ㵽
  vec3 eye= normalize(uCamera-(uMMatrix*vec4(aPosition,1)).xyz);  
  //ӱ㵽Դλõvp
  vec3 vp= normalize(lightLocation-(uMMatrix*vec4(aPosition,1)).xyz);  
  vp=normalize(vp);//ʽvp
  vec3 halfVector=normalize(vp+eye);	//ߵİ    
  float shininess=50.0;				//ֲڶȣԽСԽ⻬
  float nDotViewPosition=max(0.0,dot(newNormal,vp)); 	//vpĵ0ֵ
  diffuse=lightDiffuse*nDotViewPosition;				//ɢǿ
  float nDotViewHalfVector=dot(newNormal,halfVector);	//ĵ 
  float powerFactor=max(0.0,pow(nDotViewHalfVector,shininess)); 	//淴ǿ
  specular=lightSpecular*powerFactor;    			//㾵ǿ
}
//ӵķ
float computeFogFactor(){
   float tmpFactor;
   float fogDistance = length(uCamera-(uMMatrix*vec4(aPosition,1)).xyz);//㵽ľ
   const float end = 450.0;//λ
   const float start = 350.0;//ʼλ
   tmpFactor = max(min((end- fogDistance)/(end-start),1.0),0.0);//ʽ   	
   return tmpFactor;
}
void main()     
{
   gl_Position = uMVPMatrix * vec4(aPosition,1); //ܱ任˴λƴ˶λ   
   pointLight(normalize(aNormal),ambient,diffuse,specular,
   uLightLocation,vec4(0.4,0.4,0.4,1.0),vec4(0.7,0.7,0.7,1.0),vec4(0.3,0.3,0.3,1.0));
   //
   vFogFactor = computeFogFactor();
}